您的位置:首页 > 其它

HDU 2614 Beat (dfs)

2014-08-15 16:16 225 查看
Problem Description
Zty is a man that always full of enthusiasm. He wants to solve every kind of difficulty ACM problem in the world. And he has a habit that he does not like to solve

a problem that is easy than problem he had solved. Now yifenfei give him n difficulty problems, and tell him their relative time to solve it after solving the other one.

You should help zty to find a order of solving problems to solve more difficulty problem.

You may sure zty first solve the problem 0 by costing 0 minute. Zty always choose cost more or equal time’s problem to solve.



Input
The input contains multiple test cases.

Each test case include, first one integer n ( 2< n < 15).express the number of problem.

Than n lines, each line include n integer Tij ( 0<=Tij<10), the i’s row and j’s col integer Tij express after solving the problem i, will cost Tij minute to solve the problem j.



Output
For each test case output the maximum number of problem zty can solved.



Sample Input
3
0 0 0
1 0 1
1 0 0
3
0 2 2
1 0 1
1 1 0
5
0 1 2 3 1
0 0 2 3 1
0 0 0 3 1
0 0 0 0 2
0 0 0 0 0




Sample Output
3
2
4
Hint
Hint: sample one, as we know zty always solve problem 0 by costing 0 minute. 
So after solving problem 0, he can choose problem 1 and problem 2, because T01 >=0 and T02>=0. 
But if zty chooses to solve problem 1, he can not solve problem 2, because T12 < T01. 
So zty can choose solve the problem 2 second, than solve the problem 1.




Author
yifenfei


题意:有n道题,a[i][j]表示做完i题后做j题的难度,这个人从第0题开始做,每次做不比上次题目简单的题,问他最多做多少题?

理解题意半天,解题还是比较顺利,解释在代码中

#include<iostream>
#include<cstring>
#include<algorithm>
#include<cstdio>
using namespace std;

#define N 20

int a

,n;
int ans,vis
;

void dfs(int le,int num,int s) //le表示刚做的题,例如le=0,那么现在在第0行选择做的下一题,s是刚做题的难度
{
    int i;

    if(num>ans) ans=num; //num是已经做的题

    for(i=0;i<n;i++)
    {
        if(vis[i]||a[le][i]<s) continue;//这个题做过,或者现在做i题难度没有s(前一题的分)高

        vis[i]=1;   //假设做i题
        dfs(i,num+1,a[le][i]);
        vis[i]=0;   //取消假设
    }
}

int main()
{
    int i,j;
    while(~scanf("%d",&n))
    {
        for(i=0;i<n;i++)
            for(j=0;j<n;j++)
            scanf("%d",&a[i][j]);

        memset(vis,0,sizeof(vis));
        vis[0]=1; //题目说先做第0题
        ans=0;
        dfs(0,1,0);

        printf("%d\n",ans);
    }
    return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: